diff --git a/lib/cspf.c b/lib/cspf.c
index 6a0fb7f63cc2..c17d8e0929da 100644
--- a/lib/cspf.c
+++ b/lib/cspf.c
@@ -331,6 +331,8 @@ void cspf_clean(struct cspf *algo)
 	if (processed_count(&algo->processed)) {
 		frr_each_safe (processed, &algo->processed, path) {
 			processed_del(&algo->processed, path);
+			if (path == algo->pdst)
+				algo->pdst = NULL;
 			cpath_del(path);
 		}
 	}
@@ -343,6 +345,9 @@ void cspf_clean(struct cspf *algo)
 		}
 	}
 
+	if (algo->pdst)
+		cpath_del(algo->pdst);
+
 	memset(&algo->csts, 0, sizeof(struct constraints));
 	algo->path = NULL;
 	algo->pdst = NULL;
